const {pool} =  require('./db/db') //BASE DE DATOS
const express = require('express')
const app = express()
const expressFileUpload = require("express-fileupload");
const cookieParser = require("cookie-parser");
app.use(cookieParser());

const bodyParser = require('body-parser');
const urlencodedParser = bodyParser.urlencoded({ extended: false });

app.use(bodyParser.urlencoded({ extended: false }));
app.use(bodyParser.json());


const PORT = process.env.PORT || 3000;

console.log('Running on PORT: ' + PORT)
app.listen(PORT)

const routes = require('./routes/app-routes');

app.use('/static', express.static(__dirname + '/static'));
app.use('/images', express.static(__dirname + '/static/images'));
app.use('/video', express.static(__dirname + '/static/video'));
console.log(__dirname)


app.use('/logo', express.static(__dirname + '/logo'));

app.engine('html', require('ejs').renderFile);

app.set('view engine', 'ejs');

app.set('views', __dirname + '/views');


// app.use(
//     expressFileUpload({
//       limits: { fileSize: 50000000 },
//       abortOnLimit: true,
//       responseOnLimit:
//           "El peso de la imagen que intentas subir supera el limite permitido",
//     })
// );

app.use(routes)