const express = require('express')
const app = express()
const {pool} = require('../db/db')
const bodyParser = require('body-parser')
const jwt = require('jsonwebtoken');
const fs = require('fs')
const secretKey = 'Mi Llave Ultra Secreta'
const nodemailer = require("nodemailer");
const cookieParser = require("cookie-parser");
app.use(cookieParser());
var axios = require('axios');
require('dotenv').config();
const {Translate} = require('@google-cloud/translate').v2;



const index = async (req, res, next) => {

  const valor = req.params.valor;


    
    return res.render("index", {valor});
}

const successPayment = async (req, res, next) => {
    
  return res.render("successPayment");
}

const failedPayment = async (req, res, next) => {
    
  return res.render("failedPayment");
}


function sleep(ms) {
  return new Promise(resolve => setTimeout(resolve, ms));
}

const generateImages = async (req, res) => {
  console.log('BODY CONTENT', req.body.message);
  
  const ipAddress = req.ip;
  
  
  console.log(`La direcci�n IP de origen es: ${ipAddress}`);
  
  
  // URL de la API de traducci�n
  const url = 'https://translation.googleapis.com/language/translate/v2?';
  
  // Par�metros de la consulta
  const q = [req.body.message];
  const target = 'en';
  const format = 'text';
  const source = 'es';
  const model = 'nmt';
  const key = process.env.KEY_GOOGLE;
  
  let translated = ''
  
  // Construir la URL con los par�metros de consulta
  const queryParams = `q=${q.join(',')}&target=${target}&format=${format}&source=${source}&model=${model}&key=${key}`;
  const requestUrl = url + queryParams;
  
  // Realizar la solicitud POST
  try {
    const response = await axios.post(requestUrl);
    const json_data = response.data;
    const translations = json_data.data.translations;
  
    translations.forEach(translation => {
      console.log(translation.translatedText);
      translated = translation.translatedText;
    });
  } catch (error) {
    console.error('Error:', error.message);
  }

  
  console.log('traslated text')
  //traslated from spanish to english
  console.log(translated)
  
  const data = {
    "msg": translated,
    "ref": "",
    "webhookOverride": ""
  };

  const config = {
    method: 'post',
    url: 'https://api.thenextleg.io/v2/imagine',
    headers: {
      'Authorization': `Bearer ${process.env.TNL_TOKEN}`,
      'Content-Type': 'application/json'
    },
    data: data
  };
  
  
    
  
  try {
    const response1 = await axios(config);

    console.log(response1.data)
      
      
    console.log('ESPERANDO 80 SEGUNDOS')
    await sleep(80000); // Espera durante 80 segundos

    
    
    console.log('response1 messageId')
    console.log(response1.data.messageId)
    

    const config2 = {
      method: 'get',
      url: `https://api.thenextleg.io/v2/message/${response1.data.messageId}?expireMins=2`,
      headers: {
        'Authorization': `Bearer ${process.env.TNL_TOKEN}`,
        'Content-Type': 'application/json'
      }
    };
    
    console.log('segundo request')
    

    const response2 = await axios(config2);
    console.log(response2)
    console.log('response2 ************************************************************************************+')
    console.log(response2.data.response.imageUrl);

    
    while (response2.data.response.imageUrl == undefined) {
      console.log('Reintento')
      await sleep(10000); // Espera durante 10 segundos
      response2 = await axios(config2);
    }
    
    
    
    return res.render('index', { imageUrl: response2.data.response.imageUrl });
    
  } catch (error) {
    console.log(error);
  }

  return res.render('index', { imageUrl: false });
}

const generateImagesResponse = async (req, res) => {
//hay que guardarlo en una base de datos

  console.log(req.body.imageUrl)

  // if (req.body.imageUrl) {
   //   return res.render('index', { imageUrl: req.body.imageUrl });
    //} else {
    //
      //await new Promise((resolve) => {
        //setTimeout(() => {
          //console.log('Esto se ejecuta despu�s de 10 segundos, BUCLE');
          //resolve();
        //}, 10000);
        
      //});
      
    //}
    return res.render('index', { imageUrl: false });
}




module.exports = {
    index,
    successPayment,
    failedPayment
}
